Index: /wiki/BuildInstructions.wiki
===================================================================
--- /wiki/BuildInstructions.wiki	(revision 449)
+++ /wiki/BuildInstructions.wiki	(revision 450)
@@ -1,9 +1,9 @@
 #summary How to build XTIDE Universal BIOS.
 *Table of Contents*
-<wiki:toc max_depth="3" />
+<wiki:toc max_depth="4" />
 ----
 = Introduction =
 
-This is a small tutorial on how to build XTIDE Universal BIOS on Windows.
+This is a small tutorial on how to build XTIDE Universal BIOS on Windows. This tutorial is updated for XTIDE Universal BIOS v2.0.0 beta 2.
 
 
@@ -74,42 +74,48 @@
 == Including and excluding optional modules ==
 
-There are few optional modules (most of them are included in official release builds). Reason for modules is simple: it is not possible to get all features to fit in 8k ROM. Official builds are designed so that they include the features most users prefer.
+There are many optional modules (most of them are included in official release builds). Reason for modules is simple: it is not possible to get all features to fit in 8k ROM. Official builds are designed so that they include the features most users prefer.
 
 It is easy to include and exclude modules but it must be done by editing makefile. Makefile specifies how the binaries are build when you execute _mingw32-make_.
 
-Open makefile with Windows Notepad (or [http://notepad-plus-plus.org/ Notepad++]). You will now see all the modules and short description about them. When writing this, the makefile looks like below:
+Open makefile with Windows Notepad (or [http://notepad-plus-plus.org/ Notepad++]). You will now see all the modules and short description about them. The makefile looks like below for XTIDE Universal BIOS v2.0.0 beta 2:
 {{{
-##################################################################################################
-# Makefile to build XTIDE Universal BIOS.                                                        #
-#                                                                                                #
-# Valid makefile targets are:                                                                    #
-# all       Removes existing files and builds binary files in \Build                             #
-# small     Builds 8 kiB binaries only (without checksum)                                        #
-# large     Builds 15 kiB binaries only (without checksum)                                       #
-# clean     Removes all files from \Build                                                        #
-# checksum* Builds all and then generates checksum byte to all binary files                      #
-# strings*  Compress src\Strings.asm to src\StringsCompressed.asm                                #
-#                                                                                                #
-# * at the end of target name means that Perl is required for the job.                           #
-# Build directory must be created manually if it does not exist.                                 #
-#                                                                                                #
-#                                                                                                #
-# Following modules can be included or excluded:                                                 #
-# MODULE_ADVANCED_ATA       Native support for some VLB IDE controllers                          #
-# MODULE_BOOT_MENU          Boot Menu for selection of drive to boot from                        #
-# MODULE_EBIOS              Enhanced functions for accessing drives over 8.4 GB                  #
-# MODULE_JRIDE              Support for JR-IDE/ISA                                               #
-# MODULE_SERIAL             Virtual hard disks using serial port                                 #
-# MODULE_SERIAL_FLOPPY      Virtual floppy drives using serial port (requires MODULE_SERIAL)     #
-# MODULE_STRINGS_COMPRESSED Use compressed strings to save space                                 #
-#                                                                                                #
-# Not modules but these affect the assembly:                                                     #
-# ELIMINATE_CGA_SNOW        Prevents CGA snowing at the cost of a few bytes                      #
-# USE_186                   Use instructions supported by 80188/80186 and V20/V30 and later      #
-# USE_286                   Use instructions supported by 286 and later                          #
-# USE_386                   Use instructions supported by 386 and later                          #
-# USE_AT                    Use features supported on AT and later systems (not available on XT) #
-#                                                                                                #
-##################################################################################################
+####################################################################################################
+# Makefile to build XTIDE Universal BIOS.                                                          #
+#                                                                                                  #
+# Valid makefile targets are:                                                                      #
+# all       Removes existing files and builds binary files in \Build                               #
+# small     Builds 8 kiB binaries only (without checksum)                                          #
+# large     Builds 15 kiB binaries only (without checksum)                                         #
+# clean     Removes all files from \Build                                                          #
+# checksum* Builds all and then generates checksum byte to all binary files                        #
+# strings*  Compress src\Strings.asm to src\StringsCompressed.asm                                  #
+#                                                                                                  #
+# * at the end of target name means that Perl is required for the job.                             #
+# Build directory must be created manually if it does not exist.                                   #
+#                                                                                                  #
+#                                                                                                  #
+# Following modules can be included or excluded:                                                   #
+# MODULE_8BIT_IDE             Support for 8-BIT IDE cards like XTIDE                               #
+# MODULE_JRIDE                Support for JR-IDE/ISA                                               #
+# MODULE_ADVANCED_ATA         Native support for some VLB IDE controllers                          #
+# MODULE_BOOT_MENU            Boot Menu for selection of drive to boot from                        #
+# MODULE_EBIOS                Enhanced functions for accessing drives over 8.4 GB                  #
+# MODULE_HOTKEYS              Hotkey Bar to boot from any drive                                    #
+# MODULE_IRQ                  IDE IRQ support                                                      #
+# MODULE_SERIAL               Virtual hard disks using serial port                                 #
+# MODULE_SERIAL_FLOPPY        Virtual floppy drives using serial port (requires MODULE_SERIAL)     #
+# MODULE_STRINGS_COMPRESSED   Use compressed strings to save space                                 #
+# MODULE_FEATURE_SETS         Power Management support                                             #
+#                                                                                                  #
+# Not modules but these affect the assembly:                                                       #
+# ELIMINATE_CGA_SNOW          Prevents CGA snowing at the cost of a few bytes                      #
+# RELOCATE_INT13H_STACK       Relocates INT 13h stack to top of stolen conventional memory         #
+# RESERVE_DIAGNOSTIC_CYLINDER Reserve one L-CHS cylinder for compatibility with old BIOSes         #
+# USE_186                     Use instructions supported by 80188/80186 and V20/V30 and later      #
+# USE_286                     Use instructions supported by 286 and later                          #
+# USE_386                     Use instructions supported by 386 and later                          #
+# USE_AT                      Use features supported on AT and later systems (not available on XT) #
+#                                                                                                  #
+####################################################################################################
 }}}
 
@@ -121,16 +127,17 @@
 # Assembler preprocessor defines.                               #
 #################################################################
-DEFINES_COMMON = MODULE_BOOT_MENU MODULE_EBIOS MODULE_STRINGS_COMPRESSED
-
-DEFINES_XT = ELIMINATE_CGA_SNOW MODULE_SERIAL MODULE_SERIAL_FLOPPY
-DEFINES_XTPLUS = ELIMINATE_CGA_SNOW USE_186 MODULE_SERIAL MODULE_SERIAL_FLOPPY
-DEFINES_AT = USE_286 USE_AT MODULE_SERIAL MODULE_SERIAL_FLOPPY
-
-DEFINES_XT_LARGE = $(DEFINES_XT) MODULE_JRIDE MODULE_ADVANCED_ATA
-DEFINES_XTPLUS_LARGE = $(DEFINES_XTPLUS) MODULE_JRIDE MODULE_ADVANCED_ATA
-DEFINES_AT_LARGE = $(DEFINES_AT) MODULE_JRIDE MODULE_ADVANCED_ATA
-
-DEFINES_JRIDE_8K = ELIMINATE_CGA_SNOW MODULE_JRIDE
-DEFINES_386_8K = USE_386 USE_AT MODULE_ADVANCED_ATA
+DEFINES_COMMON = MODULE_STRINGS_COMPRESSED MODULE_HOTKEYS MODULE_EBIOS MODULE_FEATURE_SETS RESERVE_DIAGNOSTIC_CYLINDER
+DEFINES_COMMON_LARGE = MODULE_BOOT_MENU
+
+DEFINES_XT = $(DEFINES_COMMON) ELIMINATE_CGA_SNOW MODULE_8BIT_IDE MODULE_JRIDE MODULE_SERIAL MODULE_SERIAL_FLOPPY
+DEFINES_XTPLUS = $(DEFINES_COMMON) $(DEFINES_XT) USE_186
+DEFINES_AT = $(DEFINES_COMMON) USE_AT USE_286 RELOCATE_INT13H_STACK MODULE_IRQ MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_ADVANCED_ATA
+
+DEFINES_XT_LARGE = $(DEFINES_XT) $(DEFINES_COMMON_LARGE)
+DEFINES_XTPLUS_LARGE = $(DEFINES_XTPLUS) $(DEFINES_COMMON_LARGE)
+DEFINES_AT_LARGE = $(DEFINES_AT) $(DEFINES_COMMON_LARGE)
+
+DEFINES_XT_TINY = MODULE_STRINGS_COMPRESSED MODULE_8BIT_IDE
+DEFINES_386_8K = $(DEFINES_AT) USE_386
 
 
@@ -146,17 +153,64 @@
 These are the only parts in the makefile that you need to edit. The defines tell what modules are included in what builds.
 
-DEFINES_COMMON define the modules that are included in all builds.
-
-DEFINES_XT, DEFINES_XTPLUS and DEFINES_AT define what modules are included in the 8k XT/XT+ and AT builds in addition to the ones in DEFINES_COMMON.
+DEFINES_COMMON define the modules that are included in all builds and DEFINES_COMMON_LARGE define additional modules for all large (15k) builds.
+
+DEFINES_XT, DEFINES_XTPLUS and DEFINES_AT define what modules are included in the 8k XT, XT+ and AT builds in addition to the ones in DEFINES_COMMON.
 
 DEFINES_XT_LARGE, DEFINES_XTPLUS_LARGE and DEFINES_AT_LARGE are for large builds (15k by default).
 
-Finally there are DEFINES_JRIDE_8K (8k JR-IDE/ISA build) and DEFINES_386_8K (AT build for 386+ with VLB controller support).
-
-If you want to make your own 8k AT build, modify DEFINES_COMMON and DEFINES_AT to include the modules you want. Then rebuild with _mingw32-make all_ or _mingw32-make checksum_.
+Finally there are DEFINES_XT_TINY (XT build with minimal features) and DEFINES_386_8K (AT build for 386+).
+
+If you want to make your own 8k AT build, for example, modify DEFINES_COMMON and DEFINES_AT to include the modules you want. Then rebuild with _mingw32-make all_ or _mingw32-make checksum_.
 
 One more thing you might want to change is the size of large build. It is 15k by default (15360 bytes). If you want 16k binary, set ROMSIZE_LARGE to 16384. For 32k build set it to 32768.
 
 
+=== Module information ===
+
+====*MODULE_8BIT_IDE*====
+This module contains support for XTIDE rev 1 and 2 and Lo-tech XT-CF.
+
+====*MODULE_JRIDE* _(requires and automatically includes MODULE_8BIT_IDE)_====
+This module contains support for JR-IDE/ISA.
+
+====*MODULE_ADVANCED_ATA*====
+Adds native support for VLB (and eventually PCI) IDE Controllers. At the moment there is support for QDI Vision QD6500 and QD6580 VLB IDE controllers.
+
+====*MODULE_BOOT_MENU* _(requires and automatically includes MODULE_HOTKEYS)_====
+Adds boot menu to be selected from Hotkeybar. Boot menu displays drive details and allows selecting drive more easily but essentially it has all the same features as MODULE_HOTKEYS.
+
+====*MODULE_IRQ*====
+Adds IRQ support (you also need to enable IRQ with XTIDECFG.COM). IRQs have no real benefit for DOS (but can actually slow transfer rates a bit). You might want to use IRQs with more capable operating systems.
+
+====*MODULE_SERIAL*====
+Virtual hard disks using serial port. [http://code.google.com/p/xtideuniversalbios/wiki/SerialDrives Instructions for emulating Serial Drives with the XTIDE Universal BIOS]
+
+====*MODULE_SERIAL_FLOPPY* _(requires and automatically includes MODULE_SERIAL)_====
+Virtual floppy drives using serial port.
+
+====*MODULE_STRINGS_COMPRESSED*====
+Use compressed strings to save space. This module should be always included.
+
+====*MODULE_FEATURE_SETS*====
+Power Management support (you also need to enable it with XTIDECFG.COM).
+
+
+=== Other features that affect assembly ===
+
+====*ELIMINATE_CGA_SNOW*====
+Prevents CGA snowing at the cost of a few bytes.
+
+====*RELOCATE_INT13H_STACK*====
+Relocates INT 13h stack to top of stolen conventional memory. Has no noticeable performance penalty for AT systems but might slow down XT systems. If you include this to XT builds, make sure that Full Operating Mode is enabled with XTIDECFG.COM. Otherwise stack won't be relocated.
+
+====*RESERVE_DIAGNOSTIC_CYLINDER*====
+Old BIOSes reserve one diagnostic cylinder that is not used for anything. Do not include this if you have use for one extra cylinder. Note that this can cause compatibility problems if you move drives between different systems.
+
+====*USE_186, USE_286 and USE_386*====
+Determines what CPU instructions are allowed. USE_186 limits instructions to those supported by 80188/80186 and NEC V20/V30. USE_286 limits instructions for 286 compatible code and USE_386 limits instructions for 386 compatible code. XTIDE Universal BIOS uses macros that emulate the missing instructions when necessary. Do not use any of the mentioned preprocessor directives if you want to generate 8088/8086 compatible code.
+
+====*USE_AT*====
+Assembles code targeted for AT systems. For example AT builds always operate in full operating mode. Another difference is that AT builds use some BIOS functions that are not available on XT systems.
+
 ----
 = Building Configurator (XTIDECFG.COM) =